%=======================================================================
%To solve optimization problem:
%Create a new subfolder in ...\PSG\MATLAB:
%..\PSG\MATLAB\problem_production_planning_FXCHG
%Download and unpack the following zipped file from 'Data' to the created folder:
%'Mat_data_problem_production_planning_FXCHG.zip'
%Run program 'problem_production_planning_FXCHG.m'
%=======================================================================

clc;
clear;
addpath('..');

%Load data:
load('.\problem_production_planning_FXCHG_data.mat')
%Define options for PSG solver:
stroptions.Linearization = 'On';
stroptions.Precision = 9;
%Define input arguments:
string = {'fxchg_pos'};
w = {0.0001};

%Solve optimization problems:
[xout, fval, status, output] = riskprog(string, w, H, [], [], d, [], [], Aeq, beq, lb, ub, [], stroptions);
 
%Display results:
disp(' ');
disp('Results: ');
%Display status of optimization problem:
disp(sprintf('status of optimization problem = %s', status));
%Display solving time:
disp(sprintf('solving time = %g', output.solving_time));
%Display objective:
disp(sprintf('objective = %g', fval));
%Display function:
disp(sprintf('fxchg_pos= %g', output.frval));
%Display linear component of objective:
disp('linear component of objective:');
disp(output.fdval);
%Display left hand sides of linear equality:
disp('linear equality:');
disp(output.fAeqval');
%Display residual of linear equality:
disp(sprintf('residual of linear equality = %g', output.rAeqval));
%Display optimal point:
disp('optimal point = ');
disp(xout');
